/*****************************************************************************
 *
 *  LYTReader.h                                XMM Science Analysis Subsystem
 *
 *  Reader for ".lyt" layout files
 *
 *  (c) 1998  ESA  -  Written by Jon Brumfitt, Aurora
 *                 -  Exported by Jorgo Bakker, BSC to layout package
 *
 *  $Id: LYTReader.h,v 1.3 2002/08/29 15:16:13 jbakker Exp $
 *
 *****************************************************************************/

#ifndef LYTREADER_H
#define LYTREADER_H

#include <iostream>
#include <string>

#include "ParameterInfo.h"
#include "Layout.h"
#include <fstream>

//================================================================
//  Class LYTReader
//================================================================
class Cistream;

class LYTReader
{
public:
    LYTReader(ParameterInfo* info) : _is(0), _file(),_info(info), _ok(true) {};
    ~LYTReader();

    bool open(const string& filename);

    bool parseFile(Layout*& lyt);
    bool parse(Layout*& lyt);
    bool parseParameter(Layout*& lyt);
    bool parsePagedLayout(Layout*& lyt);
    bool parseFrameLayout(Layout*& lyt);
    bool parseEnableLayout(Layout*& lyt);
    bool parseChoiceLayout(Layout*& lyt);
    bool parseRowLayout(Layout*& lyt);
    bool parseColumnLayout(Layout*& lyt);

private:
    bool parsePage(Layout*& lyt, string& name);

    Cistream*      _is;
    ifstream       _file;
    ParameterInfo* _info;
    string         _filename;
    bool           _ok;
};

#endif
