// -*-C++-*-
//
// File:      LayoutParFile.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Tue May 21 14:16:58 MEST 2002

#ifndef LayoutParFile_h
#define LayoutParFile_h
#include "Layout.h"

class ParameterInfo;
class Parameter;

/*
  Creates a Layout from the parameter file alone...
 */
class LayoutParFile 
{
  
public:
  LayoutParFile(ParameterInfo* info);
  virtual ~LayoutParFile();

  bool create(Layout*& lyt);

private:
  bool createParameter(Layout*& lyt, Parameter*);
  bool createEnableLayout(Layout*& lyt,Parameter*);
  bool createChoiceLayout(Layout*& lyt,Parameter*);
  bool createColumnLayout(Layout*& lyt,Parameter*);

  // disabled member functions
  LayoutParFile();
  LayoutParFile(const LayoutParFile&);
  LayoutParFile& operator=(const LayoutParFile&);

  // data:
  ParameterInfo* _info;
};



#endif
